<?php
/**
*
* @package phpBB3
* @version $Id query_stat.php v1.0.0 2012-11-15$
* @version $Id$
* @copyrigh(c) 2012 by Aleksey
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/
/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

$tables = array (
		// Table names
		'phpbb_acl_groups' => 0,
		'phpbb_acl_options' => 0,
		'phpbb_acl_roles_data' => 0,
		'phpbb_acl_roles' => 0,
		'phpbb_acl_users' => 0,
		'phpbb_attachments' => 0,
		'phpbb_banlist' => 0,
		'phpbb_bbcodes' => 0,
		'phpbb_bookmarks' => 0,
		'phpbb_bots' => 0,
		'phpbb_config' => 0,
		'phpbb_confirm' => 0,
		'phpbb_disallow' => 0,
		'phpbb_drafts' => 0,
		'phpbb_extensions' => 0,
		'phpbb_extension_groups' => 0,
		'phpbb_forums' => 0,
		'phpbb_forums_access' => 0,
		'phpbb_forums_track' => 0,
		'phpbb_forums_watch' => 0,
		'phpbb_groups' => 0,
		'phpbb_icons' => 0,
		'phpbb_lang' => 0,
		'phpbb_log' => 0,
		'phpbb_login_attempts' => 0,
		'phpbb_mchat' => 0,
		'phpbb_moderator_cache' => 0,
		'phpbb_modules' => 0,
		'phpbb_poll_options' => 0,
		'phpbb_poll_votes' => 0,
		'phpbb_posts' => 0,
		'phpbb_privmsgs' => 0,
		'phpbb_privmsgs_folder' => 0,
		'phpbb_privmsgs_rules' => 0,
		'phpbb_privmsgs_to' => 0,
		'phpbb_profile_fields' => 0,
		'phpbb_profile_fields_data' => 0,
		'phpbb_profile_fields_lang' => 0,
		'phpbb_profile_lang' => 0,
		'phpbb_ranks' => 0,
		'phpbb_reports' => 0,
		'phpbb_reports_reasons' => 0,
		'phpbb_search_results' => 0,
		'phpbb_search_wordlist' => 0,
		'phpbb_search_wordmatch' => 0,
		'phpbb_sessions' => 0,
		'phpbb_sessions_keys' => 0,
		'phpbb_sitelist' => 0,
		'phpbb_smilies' => 0,
		'phpbb_styles' => 0,
		'phpbb_styles_template' => 0,
		'phpbb_styles_template_data' => 0,
		'phpbb_styles_theme' => 0,
		'phpbb_styles_imageset' => 0,
		'phpbb_styles_imageset_data' => 0,
		'phpbb_topics' => 0,
		'phpbb_topics_posted' => 0,
		'phpbb_topics_track' => 0,
		'phpbb_topics_watch' => 0,
		'phpbb_user_group' => 0,
		'phpbb_users' => 0,
		'phpbb_warnings' => 0,
		'phpbb_words' => 0,
		'phpbb_zebra' => 0,
		
		// phpBBex tables
		'phpbb_user_confirm_keys' => 0,
		'phpbb_user_browser_ids' => 0,
		'phpbb_post_rates' => 0,
		
		// Общая сумма запросов
		'sum_queries' => 0,
		// Время начала отсчёта запросов
		'saving_time' => time(),
);

$f_counter = $phpbb_root_path . 'work/f_counter.txt'; // файл-счётчик
$f_stat = $phpbb_root_path .'work/f_stat.txt';// сбор статистики за час
$f_queries = $phpbb_root_path .'work/f_queries.txt';// запросы к базе данных

function calc_queries($query)
{
	global $tables, $f_counter, $f_stat, $f_queries;	

	if (file_exists($f_counter))
	{
		$fp_counter = @fopen($f_counter, 'r+');
		if (!$fp_counter) return;
	}
	else
	{
		$fp_counter = @fopen($f_counter, 'w+');
		if (!$fp_counter) return;
	}
	
	
	
	
	if (flock($fp_counter, LOCK_EX)) // выполняем эксклюзивную блокировку
	{ 
		$tables_infile = @unserialize(fgets($fp_counter)); // пытаемся прочитать данные из файла
		if ($tables_infile !== false) 
		{
			$tables = $tables_infile;
		}
		ftruncate($fp_counter, 0); // очищаем файл-счётчик после считывания(удачного или неудачного) из него 
		fseek($fp_counter, 0);
	}
	else 
	{
		return;
	}		
	
	// выполняем подсчёт запросов	
	foreach($tables as $table => $query_count)
	{
		if ($table == 'sum_queries' or $table == 'saving_time') continue;
		$count_queries = substr_count($query, $table); // может использовать strpos()?
		if ($count_queries > 0)		
		{			
			$tables[$table] += $count_queries;
			$tables['sum_queries']++;
			
			// вывод запросов в файл - использовать только на локальном компьютере
			//if ($table == 'phpbb_sessions' ) file_put_contents($f_queries, $query . "\n\n",FILE_APPEND);
			//if ($table == 'phpbb_users' ) file_put_contents($f_queries, $query . "\n\n",FILE_APPEND);
			//if ($table == 'phpbb_config' ) file_put_contents($f_queries, $query . "\n\n",FILE_APPEND);
		}
	}

	// если прошел час, то сбрасываем таблицу-счётчик в файл-статистики и очищаем её
	if (time()-3600 > $tables['saving_time'])
	{
		
		$fp_stat = @fopen($f_stat, 'a'); // открываем файл для сброса статистики
		
		$tables['saving_time'] = time();
		$out_stat = 'Общее количество запросов за последний час = ' . $tables['sum_queries'] . "\n";
		$out_stat .= 'Текущее время = ' . date('d-m-Y H:i:s' ,$tables['saving_time']) . "\n";
		arsort($tables, SORT_NUMERIC); // сортировка массива по кол-ву запросов
		foreach ($tables as $table => $query_count)
		{
			if ($table == 'sum_queries' or $table == 'saving_time') continue;
			$out_stat .= "$table = $query_count\n";
		}
		
		fwrite($fp_stat, $out_stat . "________________________________\n\n");
		fflush($fp_stat);
		fclose($fp_stat);
		
		// очищаем таблицу-счётчик
		clear_tables();
	}
	
	fwrite($fp_counter, @serialize($tables)); // записывем таблицу-счётчик в файл-счётчик
	fflush($fp_counter);        // очищаем вывод перед отменой блокировки
	flock($fp_counter, LOCK_UN); // отпираем файл
	fclose($fp_counter);	
	
	return;
}

function clear_tables()
{
	global $tables;
	foreach($tables as $table => $query_count)
	{
		if ($table == 'saving_time') 
		{
			$tables[$table] = time();			
		}
		else $tables[$table] = 0;
	}	
}
?>